{****************************************************}
{}
{		CDEFTest	}
{		Handle the test CDEF's dialog	}
{}
{		Hansruedi Baer		}
{		Department of Geography	}
{		University of Zurich		}
{		Winterthurerstrasse 190	}
{		CH-8057   Z u r i c h 		}
{		e-mail: baer@gis.geogr.unizh.ch	}
{}
{****************************************************}


unit CDEFTest;

interface

	procedure InitTest (theDialog: DialogPtr);
	procedure CopyControl (theDialog: DialogPtr);
	procedure DoActivate (theWindow: WindowPtr; activate: boolean);
	procedure DoDialogItem (theDialog: DialogPtr; itemHit: integer);


implementation

	const
		kCtrl = 1;
		kDate = kCtrl + 1;
		noErr = 0;


{****************************************************}
{	InitTest	}
{}
{		Do what is appropriate for initializing.	}
{****************************************************}
	procedure InitTest (theDialog: DialogPtr);
	begin
		ErrorSound(nil);
		TextFont(geneva);
		TextSize(9);
		DoDialogItem(theDialog, kCtrl);
	end;


{****************************************************}
{	CopyControl	}
{}
{		Copy the control to the clipboard.	}
{****************************************************}
	procedure CopyControl (theDialog: DialogPtr);
		var
			itemHandle: Handle;
			control: ControlHandle;
			picture: picHandle;
			textStr: str255;
			itemRect: Rect;
			theErr: OSErr;
			itemType: integer;

	begin
		if (ZeroScrap = noErr) then
			begin
				SetPort(theDialog);
				GetDItem(theDialog, kCtrl, itemType, itemHandle, itemRect);
				control := controlHandle(itemHandle);
				picture := OpenPicture(itemRect);
				Draw1Control(control);
				ClosePicture;
				HLock(Handle(picture));
				theErr := PutScrap(picture^^.picSize, 'PICT', Handle(picture)^);
				HUnlock(Handle(picture));
				KillPicture(picture);
				GetDItem(theDialog, kDate, itemType, itemHandle, itemRect);
				GetIText(itemHandle, textStr);
				theErr := PutScrap(length(textStr), 'TEXT', Ptr(ord4(@textStr) + 1));
			end;
	end;


{****************************************************}
{	DoActivate	}
{}
{		Handle activate and deactivate events. Modesless dialogs don't.	}
{****************************************************}
	procedure DoActivate (theWindow: WindowPtr; activate: boolean);
		var
			control: controlHandle;
			itemHandle: Handle;
			itemRect: Rect;
			itemType: integer;
	begin
		GetDItem(theWindow, kCtrl, itemType, itemHandle, itemRect);
		control := controlHandle(itemHandle);
		if activate then
			HiliteControl(control, 0)
		else
			HiliteControl(control, 255);
	end;


{****************************************************}
{	DoDialogItem	}
{}
{		Handle clicks in dialog items.	}
{****************************************************}
	procedure DoDialogItem (theDialog: DialogPtr; itemHit: integer);
		var
			itemHandle: Handle;
			control: ControlHandle;
			itemRect: Rect;
			secs: Longint;
			itemType: integer;
			value: integer;
			textStr: Str255;
	begin
		case itemHit of

			kCtrl: 
				begin
					GetDItem(theDialog, itemHit, itemType, itemHandle, itemRect);
					control := controlHandle(itemHandle);
					value := GetCtlValue(control);
					secs := longint(value) * 24 * 60 * 60;
					IUDateString(secs, longDate, textStr);
					GetDItem(theDialog, kDate, itemType, itemHandle, itemRect);
					SetIText(itemHandle, textStr);
				end;
			otherwise
		end;
	end;


end.